unit tree;
{$mode objfpc}{$H+}
interface
uses Classes;
type
  PTree = ^TTree;
  generic TTree<T> = class
  private
    FItems: TList;
    FParent: PTree;
    function GetParent: TTree;
  public
    Data: T;
    property Parent: TTree read GetParent;
    constructor Create;
    destructor Destroy;
  end;

implementation

function TTree.GetParent: TTree;
begin
  if FParent = nil then Result := nil else Result := FParent^;
end;

constructor TTree.Create;
begin
  FItems := TList.Create;
end;

destructor TTree.Destroy;
begin
  FItems.Free;
end;

end.

